VampPluginSDK 2.1

- Main Page
- Namespaces
- Classes
- Files
- Directories

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Attributes
AmplitudeFollower Class Reference

Example plugin implementing the SuperCollider amplitude follower function. More...

`#include <AmplitudeFollower.h>`

Inheritance diagram for AmplitudeFollower:
[legend]

List of all members.

## Public Types
enum | InputDomain { TimeDomain, FrequencyDomain }
typedef std::vector < OutputDescriptor > | OutputList
typedef std::vector< Feature > | FeatureList
typedef std::map< int, FeatureList > | FeatureSet
typedef std::vector < ParameterDescriptor > | ParameterList
typedef std::vector< std::string > | ProgramList
## Public Member Functions
| AmplitudeFollower (float inputSampleRate)
| An implementation of SuperCollider's amplitude-follower algorithm as a simple Vamp plugin.
virtual | ~AmplitudeFollower ()
bool | initialise (size_t channels, size_t stepSize, size_t blockSize)
| Initialise a plugin to prepare it for use with the given number of input channels, step size (window increment, in sample frames) and block size (window size, in sample frames).
void | reset ()
| Reset the plugin after use, to prepare it for another clean run.
InputDomain | getInputDomain () const
| Get the plugin's required input domain.
std::string | getIdentifier () const
| Get the computer-usable name of the plugin.
std::string | getName () const
| Get a human-readable name or title of the plugin.
std::string | getDescription () const
| Get a human-readable description for the plugin, typically a line of text that may optionally be displayed in addition to the plugin's "name".
std::string | getMaker () const
| Get the name of the author or vendor of the plugin in human-readable form.
int | getPluginVersion () const
| Get the version number of the plugin.
std::string | getCopyright () const
| Get the copyright statement or licensing summary for the plugin.
OutputList | getOutputDescriptors () const
| Get the outputs of this plugin.
ParameterList | getParameterDescriptors () const
| Get the controllable parameters of this plugin.
float | getParameter (std::string paramid) const
| Get the value of a named parameter.
void | setParameter (std::string paramid, float newval)
| Set a named parameter.
FeatureSet | process (const float *const *inputBuffers, Vamp::RealTime timestamp)
| Process a single block of input data.
FeatureSet | getRemainingFeatures ()
| After all blocks have been processed, calculate and return any remaining features derived from the complete input.
virtual size_t | getPreferredBlockSize () const
| Get the preferred block size (window size -- the number of sample frames passed in each block to the process() function).
virtual size_t | getPreferredStepSize () const
| Get the preferred step size (window increment -- the distance in sample frames between the start frames of consecutive blocks passed to the process() function) for the plugin.
virtual size_t | getMinChannelCount () const
| Get the minimum supported number of input channels.
virtual size_t | getMaxChannelCount () const
| Get the maximum supported number of input channels.
virtual std::string | getType () const
| Used to distinguish between Vamp::Plugin and other potential sibling subclasses of PluginBase.
virtual unsigned int | getVampApiVersion () const
| Get the Vamp API compatibility level of the plugin.
virtual ProgramList | getPrograms () const
| Get the program settings available in this plugin.
virtual std::string | getCurrentProgram () const
| Get the current program.
virtual void | selectProgram (std::string)
| Select a program.
## Protected Attributes
size_t | m_stepSize
float | m_previn
float | m_clampcoef
float | m_relaxcoef
float | m_inputSampleRate

## Detailed Description

Example plugin implementing the SuperCollider amplitude follower function.

Definition at line 47 of file AmplitudeFollower.h.

## Member Typedef Documentation

typedef std::vector<OutputDescriptor> Vamp::Plugin::OutputList`[inherited]`

Definition at line 327 of file vamp-sdk/Plugin.h.

typedef std::vector<Feature> Vamp::Plugin::FeatureList`[inherited]`

Definition at line 385 of file vamp-sdk/Plugin.h.

typedef std::map<int, FeatureList> Vamp::Plugin::FeatureSet`[inherited]`

Definition at line 387 of file vamp-sdk/Plugin.h.

typedef std::vector<ParameterDescriptor> Vamp::PluginBase::ParameterList`[inherited]`

Definition at line 203 of file vamp-sdk/PluginBase.h.

typedef std::vector<std::string> Vamp::PluginBase::ProgramList`[inherited]`

Definition at line 225 of file vamp-sdk/PluginBase.h.

## Member Enumeration Documentation

enum Vamp::Plugin::InputDomain`[inherited]`

Enumerator:

  TimeDomain |
  FrequencyDomain |

Definition at line 152 of file vamp-sdk/Plugin.h.

## Constructor & Destructor Documentation

AmplitudeFollower::AmplitudeFollower | ( | float | inputSampleRate | ) |

An implementation of SuperCollider's amplitude-follower algorithm as a simple Vamp plugin.

Definition at line 55 of file AmplitudeFollower.cpp.

AmplitudeFollower::~AmplitudeFollower | ( |  | ) | `[virtual]`

Definition at line 64 of file AmplitudeFollower.cpp.

## Member Function Documentation

bool AmplitudeFollower::initialise | ( | size_t | inputChannels,
|  | size_t | stepSize,
|  | size_t | blockSize
| ) |  | `[virtual]`

Initialise a plugin to prepare it for use with the given number of input channels, step size (window increment, in sample frames) and block size (window size, in sample frames).

The input sample rate should have been already specified at construction time.

Return true for successful initialisation, false if the number of input channels, step size and/or block size cannot be supported.

Implements Vamp::Plugin.

Definition at line 105 of file AmplitudeFollower.cpp.

References Vamp::Plugin::getMaxChannelCount(), Vamp::Plugin::getMinChannelCount(), m_clampcoef, Vamp::Plugin::m_inputSampleRate, m_relaxcoef, and m_stepSize.

void AmplitudeFollower::reset | ( |  | ) | `[virtual]`

Reset the plugin after use, to prepare it for another clean run.

Not called for the first initialisation (i.e. initialise must also do a reset).

Implements Vamp::Plugin.

Definition at line 122 of file AmplitudeFollower.cpp.

References m_previn.

InputDomain AmplitudeFollower::getInputDomain | ( |  | ) | const`[inline, virtual]`

Get the plugin's required input domain.

If this is TimeDomain, the samples provided to the process() function (below) will be in the time domain, as for a traditional audio processing plugin.

If this is FrequencyDomain, the host will carry out a windowed FFT of size equal to the negotiated block size on the data before passing the frequency bin data in to process(). The input data for the FFT will be rotated so as to place the origin in the centre of the block. The plugin does not get to choose the window type -- the host will either let the user do so, or will use a Hanning window.

Implements Vamp::Plugin.

Definition at line 56 of file AmplitudeFollower.h.

References Vamp::Plugin::TimeDomain.

string AmplitudeFollower::getIdentifier | ( |  | ) | const`[virtual]`

Get the computer-usable name of the plugin.

This should be reasonably short and contain no whitespace or punctuation characters. It may only contain the characters [a-zA-Z0-9_-]. This is the authoritative way for a program to identify a plugin within a given library.

This text may be visible to the user, but it should not be the main text used to identify a plugin to the user (that will be the name, below).

Example: "zero_crossings"

Implements Vamp::PluginBase.

Definition at line 69 of file AmplitudeFollower.cpp.

string AmplitudeFollower::getName | ( |  | ) | const`[virtual]`

Get a human-readable name or title of the plugin.

This should be brief and self-contained, as it may be used to identify the plugin to the user in isolation (i.e. without also showing the plugin's "identifier").

Example: "Zero Crossings"

Implements Vamp::PluginBase.

Definition at line 75 of file AmplitudeFollower.cpp.

string AmplitudeFollower::getDescription | ( |  | ) | const`[virtual]`

Get a human-readable description for the plugin, typically a line of text that may optionally be displayed in addition to the plugin's "name".

May be empty if the name has said it all already.

Example: "Detect and count zero crossing points"

Implements Vamp::PluginBase.

Definition at line 81 of file AmplitudeFollower.cpp.

string AmplitudeFollower::getMaker | ( |  | ) | const`[virtual]`

Get the name of the author or vendor of the plugin in human-readable form.

This should be a short identifying text, as it may be used to label plugins from the same source in a menu or similar.

Implements Vamp::PluginBase.

Definition at line 87 of file AmplitudeFollower.cpp.

int AmplitudeFollower::getPluginVersion | ( |  | ) | const`[virtual]`

Get the version number of the plugin.

Implements Vamp::PluginBase.

Definition at line 93 of file AmplitudeFollower.cpp.

string AmplitudeFollower::getCopyright | ( |  | ) | const`[virtual]`

Get the copyright statement or licensing summary for the plugin.

This can be an informative text, without the same presentation constraints as mentioned for getMaker above.

Implements Vamp::PluginBase.

Definition at line 99 of file AmplitudeFollower.cpp.

AmplitudeFollower::OutputList AmplitudeFollower::getOutputDescriptors | ( |  | ) | const`[virtual]`

Get the outputs of this plugin.

An output's index in this list is used as its numeric index when looking it up in the FeatureSet returned from the process() call.

Implements Vamp::Plugin.

Definition at line 128 of file AmplitudeFollower.cpp.

References Vamp::Plugin::OutputDescriptor::binCount, Vamp::Plugin::OutputDescriptor::description, Vamp::Plugin::OutputDescriptor::hasFixedBinCount, Vamp::Plugin::OutputDescriptor::hasKnownExtents, Vamp::Plugin::OutputDescriptor::identifier, Vamp::Plugin::OutputDescriptor::isQuantized, Vamp::Plugin::OutputDescriptor::name, Vamp::Plugin::OutputDescriptor::OneSamplePerStep, Vamp::Plugin::OutputDescriptor::sampleType, and Vamp::Plugin::OutputDescriptor::unit.

AmplitudeFollower::ParameterList AmplitudeFollower::getParameterDescriptors | ( |  | ) | const`[virtual]`

Get the controllable parameters of this plugin.

Reimplemented from Vamp::PluginBase.

Definition at line 148 of file AmplitudeFollower.cpp.

References Vamp::PluginBase::ParameterDescriptor::defaultValue, Vamp::PluginBase::ParameterDescriptor::description, Vamp::PluginBase::ParameterDescriptor::identifier, Vamp::PluginBase::ParameterDescriptor::isQuantized, Vamp::PluginBase::ParameterDescriptor::maxValue, Vamp::PluginBase::ParameterDescriptor::minValue, Vamp::PluginBase::ParameterDescriptor::name, and Vamp::PluginBase::ParameterDescriptor::unit.

float AmplitudeFollower::getParameter | ( | std::string |  | ) | const`[virtual]`

Get the value of a named parameter.

The argument is the identifier field from that parameter's descriptor.

Reimplemented from Vamp::PluginBase.

Definition at line 188 of file AmplitudeFollower.cpp.

References m_clampcoef, and m_relaxcoef.

void AmplitudeFollower::setParameter | ( | std::string | ,
|  | float |
| ) |  | `[virtual]`

Set a named parameter.

The first argument is the identifier field from that parameter's descriptor.

Reimplemented from Vamp::PluginBase.

Definition at line 179 of file AmplitudeFollower.cpp.

References m_clampcoef, and m_relaxcoef.

AmplitudeFollower::FeatureSet AmplitudeFollower::process | ( | const float *const * | inputBuffers,
|  | Vamp::RealTime | timestamp
| ) |  | `[virtual]`

Process a single block of input data.

If the plugin's inputDomain is TimeDomain, inputBuffers will point to one array of floats per input channel, and each of these arrays will contain blockSize consecutive audio samples (the host will zero-pad as necessary). The timestamp in this case will be the real time in seconds of the start of the supplied block of samples.

If the plugin's inputDomain is FrequencyDomain, inputBuffers will point to one array of floats per input channel, and each of these arrays will contain blockSize/2+1 consecutive pairs of real and imaginary component floats corresponding to bins 0..(blockSize/2) of the FFT output. That is, bin 0 (the first pair of floats) contains the DC output, up to bin blockSize/2 which contains the Nyquist-frequency output. There will therefore be blockSize+2 floats per channel in total. The timestamp will be the real time in seconds of the centre of the FFT input window (i.e. the very first block passed to process might contain the FFT of half a block of zero samples and the first half-block of the actual data, with a timestamp of zero).

Return any features that have become available after this process call. (These do not necessarily have to fall within the process block, except for OneSamplePerStep outputs.)

Implements Vamp::Plugin.

Definition at line 200 of file AmplitudeFollower.cpp.

References Vamp::Plugin::Feature::hasTimestamp, m_clampcoef, m_previn, m_relaxcoef, m_stepSize, and Vamp::Plugin::Feature::values.

AmplitudeFollower::FeatureSet AmplitudeFollower::getRemainingFeatures | ( |  | ) | `[virtual]`

After all blocks have been processed, calculate and return any remaining features derived from the complete input.

Implements Vamp::Plugin.

Definition at line 243 of file AmplitudeFollower.cpp.

virtual size_t Vamp::Plugin::getPreferredBlockSize | ( |  | ) | const`[inline, virtual, inherited]`

Get the preferred block size (window size -- the number of sample frames passed in each block to the process() function).

This should be called before initialise().

A plugin that can handle any block size may return 0. The final block size will be set in the initialise() call.

Reimplemented in Vamp::HostExt::PluginBufferingAdapter, Vamp::HostExt::PluginInputDomainAdapter, Vamp::PluginHostAdapter, Vamp::HostExt::PluginWrapper, FixedTempoEstimator, and PercussionOnsetDetector.

Definition at line 179 of file vamp-sdk/Plugin.h.

Referenced by enumeratePlugins(), and runPlugin().

virtual size_t Vamp::Plugin::getPreferredStepSize | ( |  | ) | const`[inline, virtual, inherited]`

Get the preferred step size (window increment -- the distance in sample frames between the start frames of consecutive blocks passed to the process() function) for the plugin.

This should be called before initialise().

A plugin may return 0 if it has no particular interest in the step size. In this case, the host should make the step size equal to the block size if the plugin is accepting input in the time domain. If the plugin is accepting input in the frequency domain, the host may use any step size. The final step size will be set in the initialise() call.

Reimplemented in Vamp::HostExt::PluginInputDomainAdapter, Vamp::PluginHostAdapter, Vamp::HostExt::PluginBufferingAdapter, Vamp::HostExt::PluginWrapper, FixedTempoEstimator, and PercussionOnsetDetector.

Definition at line 194 of file vamp-sdk/Plugin.h.

Referenced by enumeratePlugins(), and runPlugin().

virtual size_t Vamp::Plugin::getMinChannelCount | ( |  | ) | const`[inline, virtual, inherited]`

Get the minimum supported number of input channels.

Reimplemented in Vamp::PluginHostAdapter, and Vamp::HostExt::PluginWrapper.

Definition at line 199 of file vamp-sdk/Plugin.h.

Referenced by enumeratePlugins(), FixedTempoEstimator::initialise(), PercussionOnsetDetector::initialise(), initialise(), SpectralCentroid::initialise(), ZeroCrossing::initialise(), PowerSpectrum::initialise(), and runPlugin().

virtual size_t Vamp::Plugin::getMaxChannelCount | ( |  | ) | const`[inline, virtual, inherited]`

Get the maximum supported number of input channels.

Reimplemented in Vamp::PluginHostAdapter, and Vamp::HostExt::PluginWrapper.

Definition at line 204 of file vamp-sdk/Plugin.h.

Referenced by enumeratePlugins(), FixedTempoEstimator::initialise(), PercussionOnsetDetector::initialise(), initialise(), SpectralCentroid::initialise(), ZeroCrossing::initialise(), PowerSpectrum::initialise(), and runPlugin().

virtual std::string Vamp::Plugin::getType | ( |  | ) | const`[inline, virtual, inherited]`

Used to distinguish between Vamp::Plugin and other potential sibling subclasses of PluginBase.

Do not reimplement this function in your subclass.

Implements Vamp::PluginBase.

Definition at line 430 of file vamp-sdk/Plugin.h.

virtual unsigned int Vamp::PluginBase::getVampApiVersion | ( |  | ) | const`[inline, virtual, inherited]`

Get the Vamp API compatibility level of the plugin.

Reimplemented in Vamp::PluginHostAdapter, and Vamp::HostExt::PluginWrapper.

Definition at line 72 of file vamp-sdk/PluginBase.h.

Referenced by enumeratePlugins().

virtual ProgramList Vamp::PluginBase::getPrograms | ( |  | ) | const`[inline, virtual, inherited]`

Get the program settings available in this plugin.

A program is a named shorthand for a set of parameter values; changing the program may cause the plugin to alter the values of its published parameters (and/or non-public internal processing parameters). The host should re-read the plugin's parameter values after setting a new program.

The programs must have unique names.

Reimplemented in Vamp::PluginHostAdapter, and Vamp::HostExt::PluginWrapper.

Definition at line 237 of file vamp-sdk/PluginBase.h.

virtual std::string Vamp::PluginBase::getCurrentProgram | ( |  | ) | const`[inline, virtual, inherited]`

Get the current program.

Reimplemented in Vamp::PluginHostAdapter, and Vamp::HostExt::PluginWrapper.

Definition at line 242 of file vamp-sdk/PluginBase.h.

virtual void Vamp::PluginBase::selectProgram | ( | std::string |  | ) | `[inline, virtual, inherited]`

Select a program.

(If the given program name is not one of the available programs, do nothing.)

Reimplemented in Vamp::HostExt::PluginBufferingAdapter, Vamp::PluginHostAdapter, and Vamp::HostExt::PluginWrapper.

Definition at line 248 of file vamp-sdk/PluginBase.h.

## Member Data Documentation

size_t AmplitudeFollower::m_stepSize`[protected]`

Definition at line 77 of file AmplitudeFollower.h.

Referenced by initialise(), and process().

float AmplitudeFollower::m_previn`[protected]`

Definition at line 78 of file AmplitudeFollower.h.

Referenced by process(), and reset().

float AmplitudeFollower::m_clampcoef`[protected]`

Definition at line 79 of file AmplitudeFollower.h.

Referenced by getParameter(), initialise(), process(), and setParameter().

float AmplitudeFollower::m_relaxcoef`[protected]`

Definition at line 80 of file AmplitudeFollower.h.

Referenced by getParameter(), initialise(), process(), and setParameter().

float Vamp::Plugin::m_inputSampleRate`[protected, inherited]`

Definition at line 436 of file vamp-sdk/Plugin.h.

Referenced by FixedTempoEstimator::D::assembleFeatures(), FixedTempoEstimator::D::calculate(), FixedTempoEstimator::D::getOutputDescriptors(), ZeroCrossing::getOutputDescriptors(), PercussionOnsetDetector::getOutputDescriptors(), initialise(), FixedTempoEstimator::D::initialise(), FixedTempoEstimator::D::lag2tempo(), SpectralCentroid::process(), ZeroCrossing::process(), PercussionOnsetDetector::process(), and FixedTempoEstimator::D::tempo2lag().

The documentation for this class was generated from the following files:

- AmplitudeFollower.h
- AmplitudeFollower.cpp